## yade 0.90.3

=== CMakeLists.txt ===
# The YADE has the following parameters to configure:
#  INSTALL_PREFIX: path, where Yade will be installed (/usr/local by default)
#  LIBRARY_OUTPUT_PATH: path to install libraries (lib by default)
#  DEBUG: compile in debug-mode (OFF by default)
#  CMAKE_VERBOSE_MAKEFILE: output additional information during compiling (OFF by default)
#  SUFFIX: suffix, added after binary-names (version number by default)
#  NOSUFFIX: do not add a suffix after binary-name (OFF by default)
#  YADE_VERSION: explicitely set version number (is defined from git-directory by default)
#  ENABLE_GUI: enable GUI option (ON by default)
#  ENABLE_CGAL: enable CGAL option (ON by default)
#  ENABLE_VTK: enable VTK-export option (ON by default)
#  ENABLE_OPENMP: enable OpenMP-parallelizing option (ON by default)
#  ENABLE_GTS: enable GTS-option (ON by default)
#  ENABLE_GL2PS: enable GL2PS-option (ON by default)
#  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
#  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default).


project(Yade C CXX)
cmake_minimum_required(VERSION 2.8)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

INCLUDE(FindPythonLibs)
INCLUDE(FindPythonInterp)
INCLUDE(FindOpenMP)
INCLUDE(FindQt4)
INCLUDE(FindVTK)
INCLUDE(FindPkgConfig)
INCLUDE(GetVersion)
INCLUDE(FindOpenGL)
INCLUDE(FindGTS)
INCLUDE(FindGL2PS)
INCLUDE(FindCGAL)

#===========================================================
IF (CMAKE_CXX_FLAGS)
  #If flags are set, add only neccessary flags
  IF (DEBUG)
    SET(CMAKE_VERBOSE_MAKEFILE 1)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -ggdb2")
  ELSE (DEBUG)
    SET(CMAKE_BUILD_TYPE Release)
    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -fPIC")
  ENDIF (DEBUG)
ELSE (CMAKE_CXX_FLAGS)
  #If flags are not set, add all usefull flags
  IF (DEBUG)
    SET(CMAKE_VERBOSE_MAKEFILE 1)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -ggdb2")
  ELSE (DEBUG)
    SET(CMAKE_BUILD_TYPE Release)
    SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
  ENDIF (DEBUG)
ENDIF (CMAKE_CXX_FLAGS)
#===========================================================
# Add possibility to use local boost installation (e.g. -DLocalBoost=1.46.1)
FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread date_time filesystem iostreams regex serialization REQUIRED)
INCLUDE_DIRECTORIES (${Boost_INCLUDE_DIRS})
# for checking purpose
MESSAGE("--   Boost_VERSION: " ${Boost_VERSION})
MESSAGE("--   Boost_LIB_VERSION: " ${Boost_LIB_VERSION})
MESSAGE("--   Boost_INCLUDE_DIRS: " ${Boost_INCLUDE_DIRS})
MESSAGE("--   Boost_LIBRARIES: " ${Boost_LIBRARIES})

FIND_PACKAGE(Eigen3)
SET(DEFAULT ON CACHE INTERNAL "Default value for enabled by default options")
SET(LINKLIBS "")
SET(CONFIGURED_FEATS "")
SET(DISABLED_FEATS "")

OPTION(ENABLE_VTK "Enable VTK" ${DEFAULT})
OPTION(ENABLE_OPENMP "Enable OpenMP" ${DEFAULT})
OPTION(ENABLE_GTS "Enable GTS" ${DEFAULT})
OPTION(ENABLE_GUI "Enable GUI" ${DEFAULT})
OPTION(ENABLE_CGAL "Enable CGAL" ${DEFAULT})
OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT})
OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" OFF)

#===========================================================
# Use Eigen3 by default
IF (EIGEN3_FOUND)
  INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
  MESSAGE(STATUS "Found Eigen3")
  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen3")
ELSE (EIGEN3_FOUND)
  FIND_PACKAGE(Eigen2)
  if (EIGEN2_FOUND)
    INCLUDE_DIRECTORIES(${EIGEN2_INCLUDE_DIR})
    MESSAGE(STATUS "Found Eigen2")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen2")
  ELSE (EIGEN2_FOUND)
    MESSAGE(FATAL_ERROR "None Eigen2 or Eigen3 were found!")
  ENDIF (EIGEN2_FOUND)
ENDIF(EIGEN3_FOUND)
#===========================================================
IF(ENABLE_VTK)
  FIND_PACKAGE(VTK COMPONENTS Common) 
  IF(VTK_FOUND)
    INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
    LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_VTK")
    SET(features "${features},vtk")
    MESSAGE(STATUS "Found VTK")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} VTK")
  ELSE(VTK_FOUND)
    MESSAGE(STATUS "VTK NOT found")
    SET(ENABLE_VTK OFF)
    SET(DISABLED_FEATS "${DISABLED_FEATS} VTK")
  ENDIF(VTK_FOUND)
ELSE(ENABLE_VTK)
  SET(DISABLED_FEATS "${DISABLED_FEATS} VTK")
ENDIF(ENABLE_VTK)
#===========================================================
IF(ENABLE_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP -fopenmp")
    MESSAGE(STATUS "Found OpenMP")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} OpenMP")
    SET(features "${features},openmp")
  ELSE(OPENMP_FOUND)
    MESSAGE(STATUS "OpenMP NOT found")
    SET(ENABLE_OPENMP OFF)
    SET(DISABLED_FEATS "${DISABLED_FEATS} OPENMP")
  ENDIF(OPENMP_FOUND)
ELSE(ENABLE_OPENMP)
  SET(DISABLED_FEATS "${DISABLED_FEATS} OPENMP")
ENDIF(ENABLE_OPENMP)
#===========================================================
IF(ENABLE_GTS)
  FIND_PACKAGE(GTS)
  FIND_PACKAGE(glib2)
  IF(GTS_FOUND AND GLIB2_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GTS ${CMAKE_GTS_CXX_FLAGS}")
    SET(CMAKE_LD_FLAGS  "${CMAKE_LD_FLAGS} ${GTS_LIBRARIES}")
    INCLUDE_DIRECTORIES(${GTS_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
    MESSAGE(STATUS "Found GTS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GTS")
    SET(features "${features},gts")
  ELSE(GTS_FOUND AND GLIB2_FOUND)
    MESSAGE(STATUS "GTS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
    SET(ENABLE_GTS OFF)
  ENDIF(GTS_FOUND AND GLIB2_FOUND)
ELSE(ENABLE_GTS)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
ENDIF(ENABLE_GTS)
#===========================================================
IF(ENABLE_GUI)
  FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui QtOpenGL)
  FIND_PACKAGE(OpenGL)
  FIND_PACKAGE(GLUT)
  FIND_PACKAGE(glib2)
  FIND_PACKAGE(QGLVIEWER)
  IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
    SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})
    SET(GUI_SRC_LIB "lib/opengl/GLUtils.cpp")
    SET(features "${features},qt4,opengl")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENGL")
    INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
    INCLUDE_DIRECTORIES(${QT_INCLUDES})
    
    MESSAGE(STATUS "Found GUI-LIBS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GUI")
  ELSE(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
    MESSAGE(STATUS "GUI-LIBS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GUI")
    SET(ENABLE_GUI OFF)
  ENDIF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
ELSE(ENABLE_GUI)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GUI")
ENDIF(ENABLE_GUI)
#===========================================================
IF(ENABLE_CGAL)  
  INCLUDE(FindGMP)
  FIND_PACKAGE(CGAL)
  FIND_PACKAGE(GMP)
  IF(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang"))) #Check for clang should be removed, when CGAL will be compilable by clang
    #INCLUDE_DIRECTORIES(${CGAL_INCLUDE_DIR})
    #INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR})
    #INCLUDE_DIRECTORIES(${GMPXX_INCLUDE_DIR})
    
    FILE(GLOB CGAL_SRC_LIB "lib/triangulation/*.cpp")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CGAL_DEFINITIONS} -DYADE_CGAL")
    SET(LINKLIBS  "${LINKLIBS};${CGAL_LIBRARIES};${GMP_LIBRARIES};${GMPXX_LIBRARIES};")
    MESSAGE(STATUS "Found CGAL")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} CGAL")
  ELSE(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
    MESSAGE(STATUS "CGAL NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
    SET(ENABLE_CGAL OFF)
  ENDIF(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
ELSE(ENABLE_CGAL)
  SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
ENDIF(ENABLE_CGAL)
#===========================================================
IF(ENABLE_LINSOLV)
  INCLUDE(FindCholmod)
  FIND_PACKAGE(Cholmod)
  IF(CHOLMOD_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CGAL_DEFINITIONS} -DLINSOLV -DFLOW_ENGINE")
    SET(LINKLIBS  "${LINKLIBS};${CHOLMOD_LIBRARIES};${AMD_LIBRARY};${CAMD_LIBRARY};${COLAMD_LIBRARY};${CCOLAMD_LIBRARY};libmetis.so;libopenblas.a;")
    MESSAGE(STATUS "Found CHOLMOD")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} cholmod")
  ELSE(CHOLMOD_FOUND)
    MESSAGE(STATUS "CHOLMOD NOT found, LINSOLV disabled")
    SET(DISABLED_FEATS "${DISABLED_FEATS} cholmod")
    SET(ENABLE_LINSOLV OFF)
  ENDIF(CHOLMOD_FOUND)
ENDIF(ENABLE_LINSOLV)
#===========================================================
IF(ENABLE_GL2PS)
  FIND_PACKAGE(GL2PS)
  IF(GL2PS_FOUND)
    INCLUDE_DIRECTORIES(${GL2PS_INCLUDE_DIR})
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GL2PS")
    SET(LINKLIBS  "${LINKLIBS};${GL2PS_LIBRARIES};")
    MESSAGE(STATUS "Found GL2PS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GL2PS")
  ELSE(GL2PS_FOUND)
    MESSAGE(STATUS "GL2PS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
    SET(ENABLE_GL2PS OFF)
  ENDIF(GL2PS_FOUND)
ELSE(ENABLE_GL2PS)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
ENDIF(ENABLE_GL2PS)

INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extra/floating_point_utilities_v3)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

#===========================================================

IF (NOT INSTALL_PREFIX)
 SET(CMAKE_INSTALL_PREFIX "/usr/local")
 MESSAGE("Yade will be installed to default path ${CMAKE_INSTALL_PREFIX}, if you want to override it use -DINSTALL_PREFIX option.")
ELSE (NOT INSTALL_PREFIX)
	GET_FILENAME_COMPONENT(CMAKE_INSTALL_PREFIX ${INSTALL_PREFIX} ABSOLUTE)
	MESSAGE("Yade will be installed to ${CMAKE_INSTALL_PREFIX}")
ENDIF (NOT INSTALL_PREFIX)

IF (NOT SUFFIX)
  SET (SUFFIX "-${YADE_VERSION}")
ENDIF (NOT SUFFIX)

IF(NOSUFFIX)   #For packaging
  SET (SUFFIX "")
ENDIF(NOSUFFIX)   #For packaging

IF(NOT LIBRARY_OUTPUT_PATH)   #For packaging
  SET (LIBRARY_OUTPUT_PATH "lib")
ENDIF(NOT LIBRARY_OUTPUT_PATH)   #For packaging

IF (NOT runtimePREFIX)
  SET (runtimePREFIX ${CMAKE_INSTALL_PREFIX})
ENDIF (NOT runtimePREFIX)

MESSAGE (STATUS "Suffix is set to " ${SUFFIX})
MESSAGE (STATUS "LIBRARY_OUTPUT_PATH is set to " ${LIBRARY_OUTPUT_PATH})
MESSAGE (STATUS "runtimePREFIX is set to " ${runtimePREFIX})
#===========================================================

SET(YADE_LIB_PATH ${CMAKE_INSTALL_PREFIX}/${LIBRARY_OUTPUT_PATH}/yade${SUFFIX})
SET(YADE_EXEC_PATH ${CMAKE_INSTALL_PREFIX}/bin)
SET(YADE_PY_PATH ${YADE_LIB_PATH}/py)
SET(YADE_DOC_PATH ${CMAKE_INSTALL_PREFIX}/share/doc/yade${SUFFIX})


SET(CMAKE_SKIP_BUILD_RPATH FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${YADE_LIB_PATH};${YADE_PY_PATH};${YADE_PY_PATH}/yade/;${YADE_PY_PATH}/yade/qt;${YADE_PY_PATH}/gts")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

#===========================================================
IF(ENABLE_GUI)
  ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/gui")
ENDIF(ENABLE_GUI)
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/py")
#===========================================================

# this is only a temporary hack, headers should be installed in the build-dir directly
# perhaps there is a proper way, have to ask
IF(NOT EXISTS "${CMAKE_BINARY_DIR}/yade")

=== gui/CMakeLists.txt ===
IF(${ENABLE_GUI})
  INCLUDE(${QT_USE_FILE})
  INCLUDE_DIRECTORIES(${QGLVIEWER_INCLUDE_DIR})
  
  SET(_GLViewer_MOC_HEADERS qt4/GLViewer.hpp;qt4/OpenGLManager.hpp)
  SET(_GLViewer_SOURCE_FILES qt4/GLViewer.cpp;qt4/_GLViewer.cpp;qt4/OpenGLManager.cpp)
  
  QT4_WRAP_CPP(_GLViewer_MOC_OUTFILES ${_GLViewer_MOC_HEADERS})
  
  ADD_LIBRARY(_GLViewer SHARED ${_GLViewer_SOURCE_FILES} ${_GLViewer_MOC_OUTFILES})
  SET_TARGET_PROPERTIES(_GLViewer PROPERTIES PREFIX "")
  TARGET_LINK_LIBRARIES(_GLViewer support core ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QT_LIBRARIES} ${QGLVIEWER_LIBRARIES} ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
  INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
  
  FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt4/*.py")
  INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
  
  EXECUTE_PROCESS(
        COMMAND "pyrcc4" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt4
        RESULT_VARIABLE rv
        )
  
  EXECUTE_PROCESS(
        COMMAND "pyuic4" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt4
        RESULT_VARIABLE rv
        )
  INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
  
ENDIF(${ENABLE_GUI})

=== py/CMakeLists.txt ===
#==================pyModules=========================================
ADD_LIBRARY(WeightedAverage2d SHARED "${CMAKE_CURRENT_SOURCE_DIR}/WeightedAverage2d.cpp")
SET_TARGET_PROPERTIES(WeightedAverage2d PROPERTIES PREFIX "")
INSTALL(TARGETS WeightedAverage2d DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_eudoxos SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_eudoxos.cpp")
SET_TARGET_PROPERTIES(_eudoxos PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_eudoxos plugins support core)
INSTALL(TARGETS _eudoxos DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_utils.cpp")
SET_TARGET_PROPERTIES(_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_utils plugins support core)
INSTALL(TARGETS _utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_packPredicates SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packPredicates.cpp")
SET_TARGET_PROPERTIES(_packPredicates PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packPredicates plugins support core)
IF(ENABLE_GTS)
  TARGET_LINK_LIBRARIES(_packPredicates _gts)
ENDIF(ENABLE_GTS)


INSTALL(TARGETS _packPredicates DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packSpheres SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packSpheres.cpp")
SET_TARGET_PROPERTIES(_packSpheres PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packSpheres plugins support core)
INSTALL(TARGETS _packSpheres DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packObb SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packObb.cpp")
SET_TARGET_PROPERTIES(_packObb PROPERTIES PREFIX "")
INSTALL(TARGETS _packObb DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(wrapper SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/yadeWrapper.cpp")
SET_TARGET_PROPERTIES(wrapper PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(wrapper plugins support)
INSTALL(TARGETS wrapper DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_customConverters SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/customConverters.cpp")
SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_customConverters plugins support)
INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")

#==================pyModules=========================================

#==================pygts=========================================
IF(ENABLE_GTS)
  FILE(GLOB SRC_PYGTS "${CMAKE_CURRENT_SOURCE_DIR}/3rd-party/pygts-0.3.1/*.c")
  ADD_LIBRARY(_gts SHARED ${SRC_PYGTS})
  SET_TARGET_PROPERTIES(_gts PROPERTIES PREFIX "")
  TARGET_LINK_LIBRARIES(_gts gts)
  INSTALL(FILES 3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/py/gts)
  INSTALL(FILES 3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/py/gts)
  INSTALL(TARGETS _gts DESTINATION ${YADE_LIB_PATH}/py/gts)
ENDIF(ENABLE_GTS)
#==================pygts=========================================

FILE(GLOB filesPY "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
SET(filesPY "${filesPY};${CMAKE_CURRENT_SOURCE_DIR}/pack/pack.py")
INSTALL(FILES ${filesPY} DESTINATION ${YADE_PY_PATH}/yade)
INSTALL(FILES 3rd-party/mtTkinter-0.3/mtTkinter.py DESTINATION ${YADE_LIB_PATH}/py)
FILE(GLOB filesPYTests "${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py")
INSTALL(FILES ${filesPYTests} DESTINATION ${YADE_PY_PATH}/yade/tests)
FILE(GLOB filesPYPerf "${CMAKE_CURRENT_SOURCE_DIR}/../examples/test/performance/*")
INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)

=== debian/changelog ===
yade (0.90.3-1~exp1) experimental; urgency=low

  * [a222e2e] Remove obsolete DM-Upload-Allowed flag.
  * [8a42102] Imported Upstream version 0.90.3

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 04 Dec 2012 19:31:12 +0100

yade (0.90.2-1~exp1) experimental; urgency=low

  * [1dd2feb] Imported Upstream version 0.90.2

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 26 Nov 2012 18:52:48 +0100

yade (0.90.1-2) experimental; urgency=low

  * [2c57531] Do not use --parallel option to escape memory exhausting.
  * [3435efb] Update watch-file.

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 19 Nov 2012 18:06:23 +0100

yade (0.90.1-1) experimental; urgency=low

  * [5965efa] Use cmake for git-version of yade.
  * [6f5e8d7] Add missing epoch in g++ version. Thanks to Jakub Wilk. 
              http://lists.debian.org/debian-devel/2012/07/msg00086.html.
  * [2a363fd] Remove old patches.
  * [7c7d6ce] Use compat-level 9.
  * [de60ab3] Use multiarch.
  * [d327303] Imported Upstream version 0.90.1
  * [e7bdd21] Add lintian-overrides for rpath-issue of openmpi.

 -- Anton Gladky <gladky.anton@gmail.com>  Sun, 18 Nov 2012 21:31:06 +0100

=== debian/control ===
Source: yade
Section: science
Priority: extra
Homepage: https://launchpad.net/yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladky.anton@gmail.com>
Vcs-Git: git://git.debian.org/git/debian-science/packages/yade.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/yade.git
Build-Depends: debhelper (>= 9), binutils-gold [amd64 i386], cmake,
 freeglut3-dev, libboost-dev (>=1.35), libboost-date-time-dev (>=1.35), 
 libboost-filesystem-dev (>=1.35), libboost-thread-dev (>=1.35), 
 libboost-regex-dev (>=1.35), libboost-python-dev (>=1.35),
 libboost-iostreams-dev (>=1.35), libboost-program-options-dev, 
 python-support, libboost-serialization-dev, libloki-dev, 
 docbook-to-man, ipython, libgts-dev, python-numpy, g++(>>4:4.0), libvtk5-dev, 
 libgl1-mesa-dev, gdb, python-matplotlib, python-tk, libeigen3-dev, 
 libqglviewer-qt4-dev, python-xlib, python-qt4, pyqt4-dev-tools, python-imaging,
 libcgal-dev, libxmu-dev, libxi-dev
Build-Depends-Indep: texlive-latex-recommended, texlive-latex-extra, lmodern, 
 texlive-pictures, texlive-xetex, libjs-jquery, python-sphinx (>=1.0.6),
 python-bibtex, graphviz, dvipng, tipa
Standards-Version: 3.9.3

Package: yade
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 python (>= 2.7), python (<<2.8), 
 python-numpy, ipython, python-matplotlib, python-tk, python-qt4, 
 python-xlib, gnuplot, python-imaging, libjs-jquery, libjs-underscore,
 gtk2-engines-pixbuf
Recommends: mencoder
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: yade-doc
Architecture: all
Section: doc
Recommends: yade
Depends: ${misc:Depends}, libjs-jquery
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build
tmpInstall = $(CURDIR)/debian/tmp
tmpDirMatplotLib = $(CURDIR)/debian/matplotlib

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export MPLCONFIGDIR := $(tmpDirMatplotLib) 
export HOME := $(tmpDirMatplotLib) 
export LD_LIBRARY_PATH :=  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade/qt:$(LD_LIBRARY_PATH); 
export YADE_PREFIX := $(tmpInstall)/usr

extra_flags += \
-DruntimePREFIX="/usr" \
-DINSTALL_PREFIX="/usr" \
-DNOSUFFIX=ON \
-DLIBRARY_OUTPUT_PATH=lib/$(DEB_HOST_MULTIARCH) \

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo

override_dh_auto_install-arch:
	dh_auto_install -a
	# generate manpages
	$(tmpInstall)/usr/bin/yade --generate-manpage yade.1
	$(tmpInstall)/usr/bin/yade-batch --generate-manpage yade-batch.1
	$(tmpInstall)/usr/bin/yade --test
	$(tmpInstall)/usr/bin/yade --check
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

override_dh_auto_install-indep: 
	#Generate docs
	cd $(CURDIR)/doc/sphinx; PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py; cd _build/latex; xelatex Yade.tex; xelatex Yade.tex; xelatex Yade.tex;
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

=== debian/watch ===
version=3
http://launchpad.net/yade/+download http://launchpad.net/yade/trunk/.*/yade-(.+).tar.bz://launchpad.net/yade/ .*/yade-(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))

## yade 0.97.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,14 +32,17 @@
 INCLUDE(FindGTS)
 INCLUDE(FindGL2PS)
 INCLUDE(FindCGAL)
-
+INCLUDE(FindNumPy)
+INCLUDE(FindLoki)
+INCLUDE(FindPythonModule)
+INCLUDE(GNUInstallDirs)
 #===========================================================
 IF (CMAKE_CXX_FLAGS)
   #If flags are set, add only neccessary flags
   IF (DEBUG)
     SET(CMAKE_VERBOSE_MAKEFILE 1)
     SET(CMAKE_BUILD_TYPE Debug)
-    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -ggdb2")
+    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG")
   ELSE (DEBUG)
     SET(CMAKE_BUILD_TYPE Release)
     SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -fPIC")
@@ -49,7 +52,7 @@
   IF (DEBUG)
     SET(CMAKE_VERBOSE_MAKEFILE 1)
     SET(CMAKE_BUILD_TYPE Debug)
-    SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -ggdb2")
+    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security")
   ELSE (DEBUG)
     SET(CMAKE_BUILD_TYPE Release)
     SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
@@ -57,6 +60,7 @@
 ENDIF (CMAKE_CXX_FLAGS)
 #===========================================================
 # Add possibility to use local boost installation (e.g. -DLocalBoost=1.46.1)
+
 FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread date_time filesystem iostreams regex serialization REQUIRED)
 INCLUDE_DIRECTORIES (${Boost_INCLUDE_DIRS})
 # for checking purpose
@@ -65,7 +69,14 @@
 MESSAGE("--   Boost_INCLUDE_DIRS: " ${Boost_INCLUDE_DIRS})
 MESSAGE("--   Boost_LIBRARIES: " ${Boost_LIBRARIES})
 
-FIND_PACKAGE(Eigen3)
+#===========================================================
+FIND_PACKAGE(NumPy REQUIRED)
+INCLUDE_DIRECTORIES(${NUMPY_INCLUDE_DIRS})
+
+FIND_PACKAGE(Loki REQUIRED)
+FIND_PACKAGE(Eigen3 REQUIRED)
+#===========================================================
+
 SET(DEFAULT ON CACHE INTERNAL "Default value for enabled by default options")
 SET(LINKLIBS "")
 SET(CONFIGURED_FEATS "")
@@ -85,15 +96,6 @@
   INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
   MESSAGE(STATUS "Found Eigen3")
   SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen3")
-ELSE (EIGEN3_FOUND)
-  FIND_PACKAGE(Eigen2)
-  if (EIGEN2_FOUND)
-    INCLUDE_DIRECTORIES(${EIGEN2_INCLUDE_DIR})
-    MESSAGE(STATUS "Found Eigen2")
-    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen2")
-  ELSE (EIGEN2_FOUND)
-    MESSAGE(FATAL_ERROR "None Eigen2 or Eigen3 were found!")
-  ENDIF (EIGEN2_FOUND)
 ENDIF(EIGEN3_FOUND)
 #===========================================================
 IF(ENABLE_VTK)
@@ -102,7 +104,7 @@
     INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
     LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_VTK")
-    SET(features "${features},vtk")
+    SET(features "${features} vtk")
     MESSAGE(STATUS "Found VTK")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} VTK")
   ELSE(VTK_FOUND)
@@ -117,10 +119,10 @@
 IF(ENABLE_OPENMP)
   FIND_PACKAGE(OpenMP)
   IF(OPENMP_FOUND)
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP -fopenmp")
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP ${OpenMP_CXX_FLAGS}")
     MESSAGE(STATUS "Found OpenMP")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} OpenMP")
-    SET(features "${features},openmp")
+    SET(features "${features} openmp")
   ELSE(OPENMP_FOUND)
     MESSAGE(STATUS "OpenMP NOT found")
     SET(ENABLE_OPENMP OFF)
@@ -140,7 +142,7 @@
     INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
     MESSAGE(STATUS "Found GTS")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GTS")
-    SET(features "${features},gts")
+    SET(features "${features} gts")
   ELSE(GTS_FOUND AND GLIB2_FOUND)
     MESSAGE(STATUS "GTS NOT found")
     SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
@@ -159,7 +161,7 @@
   IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
     SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})
     SET(GUI_SRC_LIB "lib/opengl/GLUtils.cpp")
-    SET(features "${features},qt4,opengl")
+    SET(features "${features} qt4 opengl")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENGL")
     INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
     INCLUDE_DIRECTORIES(${QT_INCLUDES})
@@ -174,6 +176,16 @@
 ELSE(ENABLE_GUI)
   SET(DISABLED_FEATS "${DISABLED_FEATS} GUI")
 ENDIF(ENABLE_GUI)
+#===========================================================
+# This one will automaticaly enable CGAL
+IF(ENABLE_PFVFLOW)
+  IF (NOT ENABLE_CGAL)
+    MESSAGE(STATUS "PFVFLOW depends on CGAL, attempting to turn ENABLE_CGAL ON")
+    SET(ENABLE_CGAL ON)
+  ENDIF (NOT ENABLE_CGAL)
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DFLOW_ENGINE")
+  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} PFVflow")
+ENDIF(ENABLE_PFVFLOW)
 #===========================================================
 IF(ENABLE_CGAL)  
   INCLUDE(FindGMP)
@@ -212,7 +224,7 @@
     SET(ENABLE_LINSOLV OFF)
   ENDIF(CHOLMOD_FOUND)
 ENDIF(ENABLE_LINSOLV)
-#===========================================================
+#===============================================
 IF(ENABLE_GL2PS)
   FIND_PACKAGE(GL2PS)
   IF(GL2PS_FOUND)
@@ -253,7 +265,7 @@
 ENDIF(NOSUFFIX)   #For packaging
 
 IF(NOT LIBRARY_OUTPUT_PATH)   #For packaging
-  SET (LIBRARY_OUTPUT_PATH "lib")
+  SET (LIBRARY_OUTPUT_PATH ${CMAKE_INSTALL_LIBDIR})
 ENDIF(NOT LIBRARY_OUTPUT_PATH)   #For packaging
 
 IF (NOT runtimePREFIX)
@@ -266,23 +278,11 @@
 #===========================================================
 
 SET(YADE_LIB_PATH ${CMAKE_INSTALL_PREFIX}/${LIBRARY_OUTPUT_PATH}/yade${SUFFIX})
-SET(YADE_EXEC_PATH ${CMAKE_INSTALL_PREFIX}/bin)
+SET(YADE_EXEC_PATH ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR})
 SET(YADE_PY_PATH ${YADE_LIB_PATH}/py)
-SET(YADE_DOC_PATH ${CMAKE_INSTALL_PREFIX}/share/doc/yade${SUFFIX})
+SET(YADE_DOC_PATH ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/doc/yade${SUFFIX})
+SET(YADE_MAN_PATH ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR})
 
 
 SET(CMAKE_SKIP_BUILD_RPATH FALSE)
 SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-SET(CMAKE_INSTALL_RPATH "${YADE_LIB_PATH};${YADE_PY_PATH};${YADE_PY_PATH}/yade/;${YADE_PY_PATH}/yade/qt;${YADE_PY_PATH}/gts")
-SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-
-#===========================================================
-IF(ENABLE_GUI)
-  ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/gui")
-ENDIF(ENABLE_GUI)
-ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/py")
-#===========================================================
-
-# this is only a temporary hack, headers should be installed in the build-dir directly
-# perhaps there is a proper way, have to ask
-IF(NOT EXISTS "${CMAKE_BINARY_DIR}/yade")

=== py/CMakeLists.txt ===
#==================pygts=========================================
IF(ENABLE_GTS)
  find_python_module(gts)
  IF (PY_gts)
    MESSAGE(STATUS "Use system gts version")
  ELSE (PY_gts)
    MESSAGE(STATUS "Use embedded version of gts. Please, consider installing the corresponding package")
    FILE(GLOB SRC_PYGTS "${CMAKE_CURRENT_SOURCE_DIR}/3rd-party/pygts-0.3.1/*.c")
    ADD_LIBRARY(_gts SHARED ${SRC_PYGTS})
    SET_TARGET_PROPERTIES(_gts PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_gts gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(TARGETS _gts DESTINATION ${YADE_LIB_PATH}/py/gts)
  ENDIF (PY_gts)
ENDIF(ENABLE_GTS)
#==================pygts=========================================

#==================pyModules=========================================

FILE(GLOB filesPY "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
SET(filesPY "${filesPY};${CMAKE_CURRENT_SOURCE_DIR}/pack/pack.py")
INSTALL(FILES ${filesPY} DESTINATION ${YADE_PY_PATH}/yade)
INSTALL(FILES 3rd-party/mtTkinter-0.3/mtTkinter.py DESTINATION ${YADE_LIB_PATH}/py)
FILE(GLOB filesPYTests "${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py")
INSTALL(FILES ${filesPYTests} DESTINATION ${YADE_PY_PATH}/yade/tests)
FILE(GLOB filesPYPerf "${CMAKE_CURRENT_SOURCE_DIR}/../examples/test/performance/*")
INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)
ADD_LIBRARY(WeightedAverage2d SHARED "${CMAKE_CURRENT_SOURCE_DIR}/WeightedAverage2d.cpp")
SET_TARGET_PROPERTIES(WeightedAverage2d PROPERTIES PREFIX "")
INSTALL(TARGETS WeightedAverage2d DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_eudoxos SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_eudoxos.cpp")
SET_TARGET_PROPERTIES(_eudoxos PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_eudoxos plugins support core)
INSTALL(TARGETS _eudoxos DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_utils.cpp")
SET_TARGET_PROPERTIES(_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_utils plugins support core)
INSTALL(TARGETS _utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_packPredicates SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packPredicates.cpp")
SET_TARGET_PROPERTIES(_packPredicates PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packPredicates plugins support core)
IF(ENABLE_GTS AND NOT(PY_gts))
  TARGET_LINK_LIBRARIES(_packPredicates _gts)
ENDIF(ENABLE_GTS AND NOT(PY_gts))


INSTALL(TARGETS _packPredicates DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packSpheres SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packSpheres.cpp")
SET_TARGET_PROPERTIES(_packSpheres PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packSpheres plugins support core)
INSTALL(TARGETS _packSpheres DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packObb SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packObb.cpp")
SET_TARGET_PROPERTIES(_packObb PROPERTIES PREFIX "")
INSTALL(TARGETS _packObb DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(wrapper SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/yadeWrapper.cpp")
SET_TARGET_PROPERTIES(wrapper PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(wrapper plugins support)
INSTALL(TARGETS wrapper DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_customConverters SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/customConverters.cpp")
SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_customConverters plugins support)
INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")

=== debian/changelog ===
yade (0.97.0-4ubuntu2) saucy; urgency=low

  * Revert changes from 0.97.0-4ubuntu1 now that #714935 is closed.
  * Revert to g++-4.7 to resolve FTBFS cause by cc1plus OOMing when
    building with g++-4.8, so we can finish the held-up transitions.
  * Drop build-dep on binutils-gold now that it comes from binutils.
  * Disable parallel builds on all arches; it fails intermittently.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 06 Jul 2013 13:59:19 -0600

yade (0.97.0-4ubuntu1) saucy; urgency=low

  * Add build-deps on libvtk5.8-qt4, tcl-vtk, python-vtk, libvtk-java
    to work around cmake-related FTBFS caused by Debian bug #714935.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 06 Jul 2013 12:22:26 -0600

yade (0.97.0-4) unstable; urgency=low

  * [39d5e4a] Use binutils-gold only in amd64 and i386. (Closes: #710313)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 29 May 2013 21:40:38 +0200

yade (0.97.0-3) unstable; urgency=low

  * [978a093] Add cgal to BD on ia64.
  * [cd9763a] Add Breaks/Replaces into libyade.
  * Update changelog for the previous upload (missed entries).

 -- Anton Gladky <gladk@debian.org>  Wed, 29 May 2013 19:48:00 +0200

yade (0.97.0-2) unstable; urgency=low

  * [49e2dbb] Use parallel build only on amd64 and i386.
  * [e061d31] Do not use python-minieigen on s390 (no binary).
  * [066e0c2] Ship libraries in libyade-package. 
              Add python-bindings. (Closes: #708469)
  * [6eb310f] Add texlive-fonts-recommended to BD.

 -- Anton Gladky <gladk@debian.org>  Mon, 20 May 2013 20:43:33 +0200

yade (0.97.0-1) unstable; urgency=low

  * [5cf366c] Imported Upstream version 0.97.0. (Closes: #701374).
  * [79c690d] Use packaged versions of python-minieigen and pygts instead of 
              embedded copies.
  * [a391f24] Use help2man to generate manpages.
  * [84b1a93] Enable parallel build on some archs. (Closes: #704046)

 -- Anton Gladky <gladk@debian.org>  Tue, 14 May 2013 22:23:41 +0200

yade (0.95.0-1~exp1) experimental; urgency=low

  * [2184d2f] Imported Upstream version 0.95.0
  * [3823f78] Add python-argparse into Depends.
  * [34afa31] Update Standards-Version to 3.9.4. No changes.
  * [a2eb063] Update copyright file.
  * [a97d638] Use wrap-and-sort for formatting.

 -- Anton Gladky <gladk@debian.org>  Tue, 05 Mar 2013 21:05:08 +0100

=== debian/control ===
Source: yade
Section: science
Priority: extra
Homepage: https://launchpad.net/yade
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Vcs-Git: git://git.debian.org/git/debian-science/packages/yade.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/yade.git
X-Python-Version: current
Build-Depends:
 g++-4.7,
 cmake,
 debhelper (>= 9),
 freeglut3-dev,
 help2man,
 ipython,
 libboost-all-dev,
 libcgal-dev [!armel],
 libeigen3-dev,
 libgl1-mesa-dev,
 libgts-dev,
 libloki-dev,
 libqglviewer-dev,
 libvtk5-dev,
 libxi-dev,
 libxmu-dev,
 pyqt4-dev-tools,
 python-all-dev (>= 2.6.6-3~),
 python-argparse,
 python-gts,
 python-imaging,
 python-matplotlib,
 python-minieigen [!s390],
 python-numpy,
 python-qt4,
 python-support,
 python-tk,
 python-xlib
Build-Depends-Indep:
 dvipng,
 graphviz,
 libjs-jquery,
 lmodern,
 python-bibtex,
 python-sphinx (>= 1.0.7+dfsg),
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-pictures,
 texlive-xetex,
 tipa
Standards-Version: 3.9.4

Package: yade
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: foreign
Depends:
 gnuplot,
 gtk2-engines-pixbuf,
 ipython,
 libyade (= ${binary:Version}),
 python-yade (= ${binary:Version}), 
 ${python:Depends},
 ${misc:Depends}
Breaks: yade (<<0.97.0-2) 
Replaces: yade (<<0.97.0-2) 
Recommends:
 mencoder
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: libyade
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Platform for discrete element modeling. Libraries
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains yade`s libraries.

Package: python-yade
Architecture: any
Section: python
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: foreign
Depends:
 libyade (= ${binary:Version}),
 python-argparse,
 python-gts,
 python-imaging,
 python-matplotlib,
 python-minieigen,
 python-qt4,
 python-tk,
 python-xlib,
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Description: Platform for discrete element modeling. Python bindings
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains python bindings for yade.

Package: yade-doc
Architecture: all
Section: doc
Recommends:
 yade
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
--- 
+++ 
@@ -3,8 +3,17 @@
 tmpInstall = $(CURDIR)/debian/tmp
 tmpDirMatplotLib = $(CURDIR)/debian/matplotlib
 
+parallelbuild_archs =
+parallel_flag = --parallel
+ifeq (,$(filter $(DEB_HOST_ARCH),$(parallelbuild_archs)))
+	parallel_flag=
+endif
+
 %:
-	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)
+	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2 $(parallel_flag)
+
+export CC  = gcc-4.7
+export CXX = g++-4.7
 
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
@@ -12,6 +21,7 @@
 export MPLCONFIGDIR := $(tmpDirMatplotLib) 
 export HOME := $(tmpDirMatplotLib) 
 export LD_LIBRARY_PATH :=  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade/qt:$(LD_LIBRARY_PATH); 
+export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 export YADE_PREFIX := $(tmpInstall)/usr
 
 extra_flags += \
@@ -31,12 +41,13 @@
 override_dh_auto_install-arch:
 	dh_auto_install -a
 	# generate manpages
-	$(tmpInstall)/usr/bin/yade --generate-manpage yade.1
-	$(tmpInstall)/usr/bin/yade-batch --generate-manpage yade-batch.1
+	help2man $(tmpInstall)/usr/bin/yade > yade.1
+	help2man $(tmpInstall)/usr/bin/yade-batch > yade-batch.1
 	$(tmpInstall)/usr/bin/yade --test
 	$(tmpInstall)/usr/bin/yade --check
 	#Delete all pyc files
 	find . -name '*.pyc' -print0 | xargs -0 rm -f
+	dh_numpy
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog
@@ -52,3 +63,14 @@
 	cd $(CURDIR)/doc/sphinx; PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py; cd _build/latex; xelatex Yade.tex; xelatex Yade.tex; xelatex Yade.tex;
 	#Delete all pyc files
 	find . -name '*.pyc' -print0 | xargs -0 rm -f
+
+override_dh_auto_test: 
+
+override_dh_installdocs-indep:
+	dh_installdocs
+	dh_sphinxdoc
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -rf $(BUILDDIR)
+
